(function($){
	$.fn.progress = function(option){
		var $progress = $(this),
			$progressBarWrap =　$progress.find('.progress-bar-wrap'),
			$radius = $progressBarWrap.find('.radius'),
			$progressBar = $progressBarWrap.find('.progress-bar'),
			$percent = $progressBarWrap.find('.percent');
		var options = $.extend({}, $.fn.progress.defaults, typeof option == 'object' && option),
            action = typeof option == 'string' ? option : options.slide

		var _width = $progressBarWrap.width();
		var _radiusWidth = (function($radius){
			var width = 0;
			$radius.each(function(){width += $(this).width();});
			return width;
		})($radius),
			_maxWidth = _width - _radiusWidth;

		var _perWidth = (_width-_radiusWidth)/options.estimateTime;

		if(action === 'complete'){
			$percent.addClass('percent_100').text('100%');
			$progressBar.width(_maxWidth);
			clearTimeout($.fn.progress.options.progressTask);
			clearTimeout($.fn.progress.options.loopTask);
			return $progress;
		}

		return $progress.each(function(){
			var $this = $(this);
			$progressBar.width(0);
			$percent.removeClass('percent_100').text('0%');
			var runProgress = function(){
				$.fn.progress.options.progressTask = setTimeout(function(){
					var _curWidth = $progressBar.width();
					if(_curWidth+_perWidth == _radiusWidth){
						$radius.hide();
					}else{
						$radius.show();
						if(_perWidth+_curWidth > _maxWidth){
							$progressBar.width(_maxWidth);
							$percent.addClass('percent_100').text('99%');
							options.loop && options.loop(); 
						}else{
							_curWidth += _perWidth;
							var _percent = parseInt((_curWidth + _radiusWidth)/_width * 100);
							$progressBar.width(_curWidth);
							$percent.text(_percent + '%');
							if(_percent > 90){
								$percent.addClass('percent_100');
							}
						}
						runProgress();
					}
				}, 1000);
			};
			if(options.loop){
				options.delay? setTimeout(options.loop, options.delay) : options.loop();
				var loopFunc = function(){
					$.fn.progress.options.loopTask = setTimeout(function(){
						options.loop();
						loopFunc();
					}, options.interval); 
				};
				var timeDif = 0;
				if(options.delay){
					timeDif = options.delay - options.interval;
				}
				timeDif>0 ? setTimeout(loopFunc, timeDif) : loopFunc();
			}
			runProgress();
		});
	};
	$.fn.progress.defaults = {
        estimateTime : 60
    };
    $.fn.progress.options = {
		loopTask : 0, 
		progressTask : 0
	};
})(jQuery);