var lanIpFilterNum = 16;
var ok_flag = 0;
var add_flag = 0;
var MIN_PORT_RANGE = 1;
var MAX_PORT_RANGE = 65535;

var g_source_num = 0;
var firewall_status = null;
var portTriggerArr = [];
var portTriggerStr = "";

var protocolStatusArray = [
	[253, "TCP/UDP"],
	[6, "TCP"],
	[17, "UDP"],
	[1, "IMCP"]
];

function portTriggerConstructor(lanip, lanport, wanip, wanport, protocol) {
	this.lanip = lanip;
	this.lanport = lanport;
	this.wanip = wanip;
	this.wanport = wanport;
	this.protocol = protocol;
}

function addLanipFilter(insertNode) {
	var addLine = null;
	var i = 1;
	addLine = "<tr class=\"user_add_line\">";
	for (i = 1; i < arguments.length; i++) {
		addLine += "<td>" + arguments[i] + "</td>";
	}
	addLine += "<td class='user_options' width='105'><span class=\"button_edit_list\">" + editBtn + "</span>&nbsp;<span class=\"button_ipfilter_delete_list\">" + new_comm_cont_act_del + "</span></td></tr>";

	var currentTrTotal = $(insertNode).size();
	$(insertNode).eq(currentTrTotal - 2).after(addLine);
}

function ipTranApply(ipaddr) {
	var ipout = [];
	var ipoutstring = '';
	var idx = 0;
	if (ipaddr == null || ipaddr == undefined || ipaddr == '') {
		return '';
	}

	ipout = ipaddr.split('.');
	if (ipout.length != 4) {
		return '';
	} else {
		for (idx = 3; idx >= 0; idx--) {
			if (ipout[idx] == '*') {
				ipout[idx] = '0';
			} else {
				break;
			}
		}
	}
	ipoutstring = ipoutstring.concat(ipout[0], '.', ipout[1], '.', ipout[2], '.', ipout[3]);
	return ipoutstring;
}

function ipTranGet(ipAddress, num) {
	var ipout = [];
	var ipoutstring = '';
	var i = 0;
	if (null == ipAddress || undefined == ipAddress || '' == ipAddress) {
		return '';
	}

	ipout = ipAddress.split('.');
	if (ipout.length != 4) {
		return '';
	} else {
		for (i = 3; i > -1; i--) {
			if ('0' == ipout[i]) {
				if (num > 0) {
					ipout[i] = '*';
					num--;
				} else {
					break;
				}
			} else {
				break;
			}
		}
	}
	ipoutstring = ipoutstring.concat(ipout[0], '.', ipout[1], '.', ipout[2], '.', ipout[3]);
	return ipoutstring;
}


function ipGetMaskNum(ipAddress) {
	var ipout = [];
	var ipoutstring = '';
	var i = 0;
	var ipaddNum = 0;
	if (null == ipAddress || undefined == ipAddress || '' == ipAddress) {
		return '';
	}

	ipout = ipAddress.split('.');
	if (ipout.length != 4) {
		return '';
	} else {
		for (i = 3; i > -1; i--) {
			if (ipout[i] == '*') {
				ipaddNum++;
			} else {
				break;
			}
		}
	}
	return ipaddNum;
}

function sourceIpTranApplyValid(ipaddr) {
	var ipout = [];
	var ipoutstring = '';
	var i = 0;
	if (ipaddr == null || ipaddr == undefined || ipaddr == '') {
		return '';
	}

	ipout = ipaddr.split('.');
	if (ipout.length != 4) {
		return '';
	} else {
		for (i = 3; i > -1; i--) {
			if (ipout[i] == '*') {
				ipout[i] = '0';
			} else {
				break;
			}
		}
	}
	ipoutstring = ipoutstring.concat(ipout[0], '.', ipout[1], '.', ipout[2], '.', ipout[3]);
	return ipoutstring;
}

function isValidIpAddressForIPFilter(address) {
	var addrParts = address.split('.');
	if (addrParts.length != 4) {
		return false;
	}

	for (i = 0; i < 4; i++) {
		if ((addrParts[i] == '*') && (i != 3)) {
			if (addrParts[i + 1] != '*') {
				return false;
			}
		}
		if (true == (isNaN(addrParts[i])) && (addrParts[i] != '*')) {
			return false;
		}

		if ('' == addrParts[i]) {
			return false;
		}

		if (addrParts[i].indexOf(' ') != -1) {
			return false;
		}

		if ((0 == addrParts[i].indexOf('0')) && (1 != addrParts[i].length)) {
			return false;
		}
	}

	if ((addrParts[0] <= 0 || addrParts[0] == 127 || addrParts[0] > 223) ||
		(addrParts[1] < 0 || addrParts[1] > 255) ||
		(addrParts[2] < 0 || addrParts[2] > 255) ||
		(addrParts[3] < 0 || addrParts[3] >= 255)) {
		return false;
	}

	return true;
}

function checkIpPort(value, name) {
	if ('' == value) {
		showQtip(name, new_ipv_warn_empty);
		return false;
	} else if (!(isVaildPortForIPFilter(value, name))) {
		return false;
	}
	return true;
}

function isVaildValue() {
	$.each($('.qtip-defaults'), function() {
		$(this).remove();
	});

	var lanIPFilterLanAddress = $.trim($('#input_lan_ip_address').val());
	var lanIPFilterLanPort = $.trim($('#input_lan_ip_port').val());
	var lanIPFilterWanAddress = $.trim($('#input_wan_ip_address').val());
	var lanIPFilterWanPort = $.trim($('#input_wan_ip_port').val());
	//||lanIPFilterLanAddress == dhcpLanIPAddress ||!isSameSubnetAddrs(sourceIpTranApplyValid(lanIPFilterLanAddress), dhcpLanIPAddress, dhcpLanNetmask)

	if ('' == lanIPFilterLanAddress ||
		!isValidIpAddressForIPFilter(lanIPFilterLanAddress)) {
		showQtip('input_lan_ip_address', new_ipv_warn_empty);
		return false;
	}

	if (!($('#select_protocol_status').val() == 1)) {
		if (!(checkIpPort(lanIPFilterLanPort, 'input_lan_ip_port'))) {
			return false;
		}
	}

	if ('' == lanIPFilterWanAddress ||
		!isValidIpAddressForIPFilter(lanIPFilterWanAddress)
	) {
		showQtip('input_wan_ip_address', new_ipv_warn_empty);
		return false;
	}
	if (!($('#select_protocol_status').val() == 1)) {
		if (!(checkIpPort(lanIPFilterWanPort, 'input_wan_ip_port'))) {
			return false;
		}
	}


	return true;
}

function initPage() {
	initPortTriggerInfo();
}

function initPortTriggerInfo() {

	$.ajax({
		url: "/cgi-bin/mycgi.cgi?ACT=get_ip_filter_config",
		type: "GET",
		data: {},
		success: function(data) {
	//		data = "192.168.1.1,20,198.6.6.5,60,TCP\n192.168.1.1,20,198.6.6.5,60,TCP\n192.168.1.1,20,198.6.6.5,60,TCP";
			portTriggerStr = data;
			portTriggerToArray(data);
			buildTable(portTriggerArr);
		}
	});
}

function triggerSubmit() {
	parent.parent.parent.Util.showAlert('<img src="/images/loading.gif"></img>');
	portTriggerTOStr();
	$.ajax({
		url: "/cgi-bin/mycgi.cgi?ACT=set_ip_filter_config",
		type: "GET",
		data: {
			filter_config_str: portTriggerStr // 1:代表查詢第二個SSID，否則請傳入0
		},
		success: function(data) {
			if (data * 1 == 1) {
				father.jAlert(strWpsStatusFail);
				parent.parent.parent.Util.closeAlert();
			} else if (data * 1 == 0) {
				parent.parent.parent.Util.closeAlert();
			}
		}
	});
}

function buildTable(data) {
	if(data == ""){
		return;
	}
	for (var i = 0; i < portTriggerArr.length; i++) {
		addLanipFilter($('#service_list tr'), portTriggerArr[i].lanip, portTriggerArr[i].lanport, portTriggerArr[i].wanip, portTriggerArr[i].wanport, portTriggerArr[i].protocol);
	}
}

function portTriggerToArray(data) {
	if(data == "")
	{
		portTriggerArr = [];
		return;
	}
	var dataTmp = data.split("@");
	var OneData = "";
	portTriggerArr = [];
	for (var i = 0; i < dataTmp.length; i++) {
		var OneData = dataTmp[i].split(",");
		var obj = new portTriggerConstructor(OneData[0], OneData[1], OneData[2], OneData[3], OneData[4]);
		portTriggerArr.push(obj);
	}
}

function portTriggerTOStr() {
	var oneStr = "";
	portTriggerStr = "";
	for (var i = 0; i < portTriggerArr.length; i++) {
		oneStr = portTriggerArr[i].lanip + "," + portTriggerArr[i].lanport+ "," + portTriggerArr[i].wanip+ "," + portTriggerArr[i].wanport+ "," + portTriggerArr[i].protocol;
		if (i == (portTriggerArr.length - 1)) {
			portTriggerStr += oneStr;
		} else {
			portTriggerStr += oneStr + "@";
		}
	}
}

function changeArr(idx, lanip, lanport, wanip, wanport, protocol) {
	portTriggerArr[idx].lanip = lanip;
	portTriggerArr[idx].lanport = lanport;
	portTriggerArr[idx].wanip = wanip;
	portTriggerArr[idx].wanport = wanport;
	portTriggerArr[idx].protocol = protocol;
	console.log(portTriggerArr);
}


$(document).ready(function() {
	initPage();
	$('.user_options').attr('width', '105');
	var currentAllVal = null;
	var editIndex = null;
	var editWanIpAddr = null;
	var editWanPort = null;
	var editProtocol = null;
	var editStatus = null;
	$('.button_edit_list').live('click', function() {

		if (($(".add_item_control").css("display") == "none") && ($('#edit_item_ok').size() < 1)) {
			$("#addPortTrigger").addClass("disable");
			$("#applyTrigger").addClass("disable");
			editIndex = $('.button_edit_list').index(this);
			// save the value before user edit
			currentAllVal = $('.user_add_line').eq(editIndex).html();
			var editLanIpFilter = $(this).parent().siblings();
			var editLanIpAddr = editLanIpFilter.eq(0);
			var editLanPort = editLanIpFilter.eq(1);
			editWanIpAddr = editLanIpFilter.eq(2);
			editWanPort = editLanIpFilter.eq(3);
			editProtocol = editLanIpFilter.eq(4);
			//	editStatus = editLanIpFilter.eq(3);

			var htmlProtocol = editProtocol.html();
			//	var htmlStatus = editStatus.html();
			editLanIpAddr.html('<input type="text" value="' + editLanIpAddr.html() + '" id="input_lan_ip_address"></td>');
			editLanPort.html('<input type="text" value="' + editLanPort.html() + '" id="input_lan_ip_port"></td>');
			editWanIpAddr.html('<input type="text" value="' + editWanIpAddr.html() + '" id="input_wan_ip_address"></td>');
			editWanPort.html('<input type="text" value="' + editWanPort.html() + '" id="input_wan_ip_port"></td>');

			createSelect(editProtocol, 'select_protocol_status', protocolStatusArray);
			//	createSelect(editStatus, 'select_status', filterStatusArray);

			$('#select_protocol_status').val(getDArrayElement(protocolStatusArray, htmlProtocol, 'key'));
			//	$('#select_status').val(getDArrayElement(filterStatusArray, htmlStatus, 'key'));

			$(this).parent().html('<a id="edit_item_ok" href="javascript:void(0);">' + strOK +
				'</a>&nbsp<a id="edit_item_cancel" href="javascript:void(0);">' + cancelBtn + '</a>');

			hideAddItemControl();
			$("#input_lan_ip_address").focus();
			/*
			if ($('#select_protocol_status').val() == 1) {
				$('#input_lan_ip_port').val('');
				$('#input_wan_ip_port').val('');
				$('#input_lan_ip_port').attr('disabled', 'disabled');
				$('#input_wan_ip_port').attr('disabled', 'disabled');
			}*/
			$('#select_protocol_status').change(function() {
				if ($('#select_protocol_status').val() == 1) {
					$('#input_lan_ip_port').val('');
					$('#input_wan_ip_port').val('');
					$('#input_lan_ip_port').attr('disabled', 'disabled');
					$('#input_wan_ip_port').attr('disabled', 'disabled');
				} else {
					$('#input_lan_ip_port').removeAttr('disabled');
					$('#input_wan_ip_port').removeAttr('disabled');
				}
			});
			$('#edit_item_cancel').live('click', function() {
				$('.user_add_line').eq(editIndex).html(currentAllVal);
				$('.qtip').qtip('destroy');
				$("#addPortTrigger").removeClass("disable");
				$("#applyTrigger").removeClass("disable");
				if (!isButtonEnable('add_item')) {
					//    button_enable('add_item', '1');
					if ((1 == ok_flag) || (1 == add_flag)) {
						//	    button_enable('apply', '1');
					}
				}
				if ($('.user_add_line').length >= lanIpFilterNum) {
					//	button_enable('add_item', '0');
				}
			});
			$('#add_item').live('click', function() {
				if (isButtonEnable('add_item')) {
					$('.user_add_line').eq(editIndex).html(currentAllVal);
					$('.qtip').qtip('destroy');
				}
			});

			//	button_enable('apply', '0');
			//	button_enable('add_item', '0');			
		}

	});

	$('#edit_item_ok').live('click', function() {
		if (isVaildValue()) {
			var lanAddress = $.trim($('#input_lan_ip_address').val());
			var lanPort = $.trim($('#input_lan_ip_port').val());
			var wanAddress = $.trim($('#input_wan_ip_address').val());
			var wanPort = $.trim($('#input_wan_ip_port').val());
			var serviceOption = $('#select_protocol_status option:selected').text();
			//	var statusOption = $('#select_status option:selected').text();

			hideAddItemControl();
			var editLanIpFilter = $(this).parent().siblings();

			editLanIpFilter.eq(0).html(lanAddress);
			editLanIpFilter.eq(1).html(lanPort);
			editLanIpFilter.eq(2).html(wanAddress);
			editLanIpFilter.eq(3).html(wanPort);
			editLanIpFilter.eq(4).html(serviceOption);
			//	editLanIpFilter.eq(5).html(statusOption);
			//修改数组中的数据。
			changeArr(editIndex, lanAddress, lanPort, wanAddress, wanPort, serviceOption);

			$(this).parent().html('<span class=\"button_edit_list\">' + editBtn +
				'</span>&nbsp<span class=\"button_ipfilter_delete_list\">' + delBtn + '</span>');

			currentAllVal = $('.user_add_line').eq(editIndex).html();
			$("#applyTrigger").removeClass("disable");
			$("#addPortTrigger").removeClass("disable");
			$('.qtip').qtip('destroy');
			ok_flag = 1;
			if ($('.user_add_line').length >= lanIpFilterNum) {
				//button_enable('add_item', '0');
			}
		}
	});



	$('#add_item_ok').live('click', function() {
		if (isVaildValue()) {
			var lanAddress = $.trim($('#input_lan_ip_address').val());
			var lanPort = $.trim($('#input_lan_ip_port').val());
			var wanAddress = $.trim($('#input_wan_ip_address').val());
			var wanPort = $.trim($('#input_wan_ip_port').val());
			var serviceOption = $('#select_protocol_status option:selected').text();
			//   var statusOption = $('#select_status option:selected').text();
			var obj = new portTriggerConstructor(lanAddress, lanPort, wanAddress, wanPort, serviceOption);
			portTriggerArr.push(obj);
			hideAddItemControl();
			addLanipFilter($('#service_list tr'), lanAddress, lanPort, wanAddress, wanPort, serviceOption);
			$("#addPortTrigger").removeClass("disable");
			$("#applyTrigger").removeClass("disable");
			/*
       if ('0' == g_config_firewall.lanipfilter.wan)
        {
            addLanipFilter($('#service_list tr'), lanAddress, lanPort, serviceOption, statusOption);
        }
        else if('0' == g_config_firewall.lanipfilter.lan_enable)
        {
            addLanipFilter($('#service_list tr'), wanAddress, wanPort, serviceOption, statusOption);
        }
        else
        {
            addLanipFilter($('#service_list tr'), lanAddress, lanPort, wanAddress, wanPort, serviceOption, statusOption);
        }
		*/
			//     button_enable('apply', '1');

			if ($('.user_add_line').length >= lanIpFilterNum) {
				//  button_enable('add_item', '0');
			}
			add_flag = 1;
		}
		return false;
	});



	//hide add item control
	$('#add_item_cancel').live('click', function() {
		hideAddItemControl();
		$("#addPortTrigger").removeClass("disable");
		$("#applyTrigger").removeClass("disable");
		$('.qtip').qtip('destroy');
		if ((1 == add_flag) || (1 == ok_flag)) {
			//		button_enable('apply', '1');
		}
		return false;
	});

	//show add item control
	$('#add_item').click(function() {
		if (isButtonEnable('add_item')) {
			showAddItemControl();
			$('.add_item_control input').eq(0).focus();
			//	button_enable('apply', '0');
			$('#input_lan_ip_address').removeAttr('disabled');
			$('#input_lan_ip_port').removeAttr('disabled');
			$('#input_wan_ip_address').removeAttr('disabled');
			$('#input_wan_ip_port').removeAttr('disabled');
			if ($('#select_protocol_status').val() == 1) {
				$('#input_lan_ip_port').attr('disabled', 'disabled');
				$('#input_wan_ip_port').attr('disabled', 'disabled');
			}
		}
	});
	//if there hasn't any add or delete button it won't work
	$(".button_ipfilter_delete_list").live("click", function() {
		if ($(".add_item_control:hidden").size() > 0 && $("#edit_item_ok").size() < 1) {
			index = $('.button_ipfilter_delete_list').index(this);
			$(this).parent().parent().remove();
			portTriggerArr.splice(index, 1);
		}
	});

	$('#apply').click(function() {

	});
});


function isSameSubnetAddrs(ip1, ip2, mask) {
	var addrParts1 = ip1.split(".");
	var addrParts2 = ip2.split(".");
	var maskParts = mask.split(".");
	for (i = 0; i < 4; i++) {
		if (((Number(addrParts1[i])) & (Number(maskParts[i]))) != ((Number(addrParts2[i])) & (Number(maskParts[i])))) {
			return false;
		}
	}
	return true;
}

function isVaildPortForIPFilter(port, showTarget) {
	var portParts = $.trim(port);
	if ('' == portParts) {
		showQtip(showTarget, new_ipv_warn_empty);
		return false;
	}
	if (port < MIN_PORT_RANGE || port > MAX_PORT_RANGE) {
		showQtip(showTarget, firewall_hint_port_number_valid_char);
		return false;
	}
	var splitPort = portPartsParse(port);

	var i = 0;
	for (i = 0; i < splitPort.length; i++) {
		if (isNaN(splitPort[i])) {
			showQtip(showTarget, new_ipv_warn_empty);
			return false;
		}
	}
	portParts = $.trim(port);
	if (portParts.indexOf('-') == -1) {
		if (!isVaildSpecialPort(portParts, showTarget)) {
			return false;
		}
	} else {
		portParts = port.split('-');
		if (portParts.length == 2) {
			for (i = 0; i < 2; i++) {
				if (isNaN(portParts[i]) == true) {
					showQtip(showTarget, new_ipv_warn_empty);
					return false;
				}

				if (portParts[i] == '') {
					showQtip(showTarget, new_ipv_warn_empty);
					return false;
				}

				if (!isVaildSpecialPort(portParts[i], showTarget)) {
					return false;
				}
			}
			if (parseInt(portParts[0], 10) > parseInt(portParts[1], 10)) {
				showQtip(showTarget, firewall_hint_start_greater_end_port);
				return false;
			}
		} else {
			showQtip(showTarget, new_ipv_warn_empty);
			return false;
		}
	}
	return true;
}

function isVaildSpecialPort(port, showTarget) {
	var portParts = $.trim(port);
	var c = '';
	var i = 0;

	if ('' == portParts) {
		showQtip(showTarget, new_ipv_warn_empty);
		return false;
	}
	if ((portParts.indexOf('0') == 0) && (portParts.length != 1)) {
		showQtip(showTarget, new_ipv_warn_empty);
		return false;
	}

	for (i = 0; i < portParts.length; i++) {
		c = portParts.toLowerCase().charAt(i);
		if ((c >= '0') && (c <= '9')) {
			continue;
		} else {
			showQtip(showTarget, new_ipv_warn_empty);
			return false;
		}
	}

	if ((portParts < MIN_PORT_RANGE) || (portParts > MAX_PORT_RANGE)) {
		showQtip(showTarget, firewall_hint_port_number_valid_char);
		return false;
	}

	return true;
}

// function for split port
function portPartsParse(_port) {
	var portArray = [];
	_port = $.trim(_port);
	if (_port.indexOf('-') == -1) {
		portArray = [_port, _port];
	} else {
		_port = _port.split('-');
		portArray = [$.trim(_port[0]), $.trim(_port[1])];
	}
	return portArray;
}

//hide add item control
function hideAddItemControl() {
	$(".add_item_control").hide();
}

function showAddItemControl() {
	$(".add_item_control").show();
}


function addPortTrigger() {
	if ($(".add_item_control").css("display") == "table-row") {
		$("#input_lan_ip_address").focus();
		return;
	}
	$("#addPortTrigger").addClass("disable");
	$("#applyTrigger").addClass("disable");
	$("#input_lan_ip_port").val("");
	$("#input_wan_ip_address").val("");
	$("#input_wan_ip_port").val("");
	showAddItemControl();
	$("#input_lan_ip_address").focus().val("");

}

function protocolChange() {
	if ($('#select_protocol_status').val() == 1) {
		$('#input_lan_ip_port').val('');
		$('#input_wan_ip_port').val('');
		$('#input_lan_ip_port').attr('disabled', 'disabled');
		$('#input_wan_ip_port').attr('disabled', 'disabled');
	} else {
		$('#input_lan_ip_port').removeAttr('disabled');
		$('#input_wan_ip_port').removeAttr('disabled');
	}
}

function createSelect(where, id, option) {
	where.html("<select id=" + id + "></select>");

	if ($.isArray(option)) {
		$(option).each(function(n) {
			$("#" + id).append("<option value=" + option[n][0] + ">" + option[n][1] + "</option>");
		});
	}
}


function hideAddItemControl() {
	$(".add_item_control").hide();
}

function getDArrayElement(obj, item, which) {
	var val = "";
	if (obj && $.isArray(obj)) {
		$(obj).each(function(i) {
			if ("value" == which) {
				if (obj[i][0] == item) {
					val = obj[i][1];
				}
			} else if ("key" == which) {
				if (obj[i][1] == item) {
					val = obj[i][0];
				}
			} else {
				log.debug("which is error");
			}
		});
	}

	return val;
}

function isButtonEnable(button_id) {
	return false;
	var disable = true;
	var $button = $('#' + button_id);
	if ($button) {
		if ($button.children()) {
			disable = $button.attr('disabled');
		}
	}
	return !disable;
}