sts_limit = isNaN(sts_limit) ? "0" : sts_limit;
var timerRunning;
var timerID;
var delay_ms = 60000;
var reqType;
var father = parent.parent.parent;

// 取小數2位
function formatFloat(num) {
	var num = new Number(num);
	return num.toFixed(2);
}

// process 123456 --> 123.45 KB
function toBytes(bb) {
	var so = '';
	var bb2;
	var dByK = bb / 1024; // ----
	if (dByK < 1)
		return bb + ' Bytes';

	bb2 = dByK;
	dByK = bb2 / 1024; // ----
	if (dByK < 1)
		return formatFloat(bb2, 2) + ' KB';

	bb2 = dByK;
	dByK = bb2 / 1024; // ----
	if (dByK < 1)
		return formatFloat(bb2, 2) + ' MB';

	return formatFloat(dByK, 2) + ' GB';
}

function secsToTimeStr(tmSec) {
	var upStr = '';
	var upTime = tmSec * 1;

	if (upTime >= (60 * 60 * 24)) {
		upStr = Math.floor(upTime / (60 * 60 * 24)) + daysText;
		upTime = upTime % (60 * 60 * 24);
	}

	if (upTime >= (60 * 60)) {
		upStr = upStr + Math.floor(upTime / (60 * 60)) + hoursText;
		upTime = upTime % (60 * 60);
	}

	if (upTime >= (60)) {
		upStr = upStr + Math.floor(upTime / (60)) + minsText;
		upTime = upTime % (60);
	}

	upStr = upStr + Math.floor(upTime) + secsText;
	return upStr;
}

function showCurTime(secs) {
	var upStr = secsToTimeStr(secs);
	document.getElementById("up_time_cur").innerHTML = upStr;
}

function showTotalTime(secs) {
	var upStr = secsToTimeStr(secs);
	document.getElementById("up_time").innerHTML = upStr;
}

function pageInit() {
	$("div.nav li").on("click", function() {
		var id = $(this).attr("id");
		$("div.right").addClass("hide");
		$("div.nav li").removeClass("selected");
		$("div." + id).removeClass("hide");
		$(this).addClass("selected");
	});
	$("#subset").val(applyBtn);
	$("#subset").on("click", subSet);
}

function totalvolumeCheck(){
	var volume = $("#totalvolume").val();
	if (volume.length == 0 || !/^\d{1,}$/.test(volume)) {
//	father.Util.showAlert(s_setting_tips, 2000);
	showInputWarn("totalvolume",s_setting_tips);
	return;
	}
	removeInputWarn("totalvolume");
}

function wvolumeCheck(){
	var volume1 = $("#wvolume").val();
	if (volume1.length == 0 || !/^\d{1,}$/.test(volume1)) {
//	father.Util.showAlert(s_setting_tips, 2000);
	showInputWarn("wvolume",s_setting_tips);
	return;
	}
	if (volume1 * 1 > volume * 1) {
//	father.Util.showAlert(networkControl, 2000);
	showInputWarn("wvolume",networkControl);
	return;
	}
	removeInputWarn("wvolume");
}

function subSet() {
	var volume = $("#totalvolume").val();
	var volume1 = $("#wvolume").val();
	var day = $("#datepicker").val();
	day = (day.split("/")[1]) * 1;
	var controrEnable = 0;
	if (volume.length == 0 || !/^\d{1,}$/.test(volume)) {
		$("#totalvolume").focus();
		return;
	}
	if (volume1.length == 0 || !/^\d{1,}$/.test(volume1)) {
	//	father.Util.showAlert(s_setting_tips, 2000);
		$("#wvolume").focus();
		return;
	}
	if (day.length == 0 || !/^\d{1,}$/.test(day) || +day > 31 || +day < 1) {
		father.jAlert(date_error);
		return;
	}
	if (volume1 * 1 > volume * 1) {
	//	father.Util.showAlert(networkControl, 2000);
		$("#wvolume").focus();
		return;
	}
	if ($("#statistics_control").hasClass("checked"))
		controrEnable = 1;
	else
		controrEnable = 0;
	$.ajax({
		url: "/cgi-bin/mycgi.cgi?ACT=SetStatisData",
		data: {
			STS_OnOff: controrEnable,
			STSCylDay: day, // 以每月那一天為起點
			STSWarnSize: volume1, // 流量警告上限, 此為 4 MB，超過會有警告
			STSLimit: volume
		},
		success: function(data) {
			if (data == '0') {
				father.jAlert(setSuccess);
				loadSettings();
			} else {
				father.jAlert(s_setting_tips2);
			}
		}
	});
}

function doConfirmed() {
	doRequest(2);
	unloadPopupBox();
}

function confirmClr() {
	loadPopupBox();
	return false;
}

// =============== timer =================

function doRequest(typ) {
	reqType = typ;
	switch (reqType) {
		case 1:
			$.ajax({
				url: "/cgi-bin/mycgi.cgi?ACT=GetMobilStatistic",
				success: function(data) {
					UpgradeUpdateHTML(data);
				}
			});
			break;
		case 2:
			$.ajax({
				url: "/cgi-bin/mycgi.cgi?ACT=ResetMobilStatistic",
				data: {
					resetdate: serverTimeStr
				},
				success: function(data) {
					UpgradeUpdateHTML(data);
				}
			});
	}
}

//////////// AJAX //////////////
function UpgradeUpdateHTML(str) {
	if (str.length <= 0) {
		return;
	}

	switch (reqType) {
		case 1:
			var iBytes, s1;
			var ss = str.split("\n");

			// total download bytes
			if (ss[0].length <= 0)
				iBytes = 0;
			else
				iBytes = ss[0] * 1;
			s1 = toBytes(iBytes);
			document.getElementById("bytes_down").innerHTML = s1;

			// total upload bytes
			if (ss[1].length <= 0)
				iBytes = 0;
			else
				iBytes = ss[1] * 1;
			s1 = toBytes(iBytes);
			document.getElementById("bytes_up").innerHTML = s1;

			// total sum bytes
			if (ss[0].length <= 0)
				iBytes = 0;
			else
				iBytes = ss[1] * 1 + ss[0] * 1;
			s1 = toBytes(iBytes);
			$("#bytes_total").html(s1);
			//不同颜色
			if (openflag) {
				if (iBytes > lVolume * 1024 * 1024) {
					$("#bytes_total").parent().css("background", "#ff0000");
				} else if (iBytes > wVolume * 1024 * 1024) {
					$("#bytes_total").parent().css("background", "yellow");
				} else {
					$("#bytes_total").parent().css("background", "none");
				}
			}
			// cur download bytes
			if (ss[2].length <= 0)
				iBytes = 0;
			else
				iBytes = ss[2] * 1;
			s1 = toBytes(iBytes);
			document.getElementById("bytes_down_cur").innerHTML = s1;

			// cur upload bytes
			if (ss[3].length <= 0)
				iBytes = 0;
			else
				iBytes = ss[3] * 1;
			s1 = toBytes(iBytes);
			document.getElementById("bytes_up_cur").innerHTML = s1;

			// cur sum bytes
			if (ss[2].length <= 0)
				iBytes = 0;
			else
				iBytes = ss[2] * 1 + ss[3] * 1;
			s1 = toBytes(iBytes);
			document.getElementById("bytes_total_cur").innerHTML = s1;

			// cur duration
			iBytes = ss[4] * 1;
			showCurTime(iBytes);

			// cur total duration
			iBytes = ss[5] * 1;
			showTotalTime(iBytes);
			// set next timer if response ok
			return;
		case 2:
			location.reload(true);
	}
}

// popup
function unloadPopupBox() { // TO Unload the Popupbox
	$('#boxConfirm').fadeOut("slow");
	$('#contentFrame').css({ // this is just for style
		"opacity": "1"
	});
	popup_open_time = 0;
}

// To Load the Popupbox
function loadPopupBox() {
	var ss, dt1;

	$('#boxConfirm').fadeIn("slow");
	$('#contentFrame').css({ // this is just for style
		"opacity": "0.3"
	});
}

function loadSettings() {
	$.ajax({
		url: "/cgi-bin/mycgi.cgi?ACT=GetStatisData",
		success: function(data) {
			var datas = data.split(",");
			if (datas[0] * 1 == 0) {
				$("#statistics_control").removeClass("checked");
				$("#totalvolume").attr("disabled", true);
				$("#wvolume").attr("disabled", true);
				$("#datepicker").attr("disabled", true);
				$("#bytes_total").parent().css("background", "none");
				$('#pin_enable_show').html(disable);
				openflag = false;
			} else {
				$("#bytes_total").parent().css("background", "#ff0000");
				$("#statistics_control").addClass("checked");
				$("#totalvolume").attr("disabled", false);
				$("#wvolume").attr("disabled", false);
				$("#datepicker").attr("disabled", false);
				$('#pin_enable_show').html(enable);
				//	$("#subset").attr("disabled",false);
				//	$('#subset').css('background-image',"linear-gradient(to bottom, #0075c2, #0075c2)");
				openflag = true;
			}
			wVolume = datas[3] ? datas[3] : 0;
			lVolume = datas[2] ? datas[2] : 0;
			var sday = ~~(datas[1] ? datas[1] : 1);
			$("#totalvolume").val(lVolume);
			$("#wvolume").val(wVolume);
			var curDay = $("#datepicker").context.lastModified.split("/");
			if (datas[1] < 10)
				$("#datepicker").val(curDay[0] + "/0" + datas[1] + "/" + curDay[2].substring(0, 4));
			else
				$("#datepicker").val(curDay[0] + "/" + datas[1] + "/" + curDay[2].substring(0, 4));
			//	buildVolDayList(datas[1]);
			doRequest(1);
			window.setInterval(function() {
				doRequest(1);
			}, 10000);
			if (datas[0] * 1 == 0) {
				showRemainTime(sday, false);
			} else {
				showRemainTime(sday, true);
			}
		}
	});
}

function buildVolDayList(DayVal) {
	var ss = "";
	var $myselect = $("#volumeday");
	DayVal = DayVal ? DayVal : 1;
	for (var i = 1; i <= 31; i++) {
		ss += '<option ';
		ss += "value='" + i + "'"
		if (i == DayVal) {
			ss += 'selected';
			$myselect[0].selectedIndex = i;
		}
		ss = ss + '>' + i + '</option>\n';
	}
	$myselect.append(ss);
	return;
}

function volumedayChanged() {


}


function showRemainTime(sday, flag) {
	/*var now = new Date();
	var nday = now.getDate();
	var str = now.getHours()+"h "+now.getMinutes()+"min";
	if(nday >= sday){
		str = nday-sday+"d "+str;
	}else{
		now.setDate(0); 
    	str = now.getDate()-sday+nday+"d "+str;
	}*/
	//剩余多少时间
	if (!flag) {
		$("#r-time").html("--");
		return;
	}
	var now = new Date();
	var nowtime = now.getTime();
	var nday = now.getDate();
	if (sday <= nday) {
		now.setMonth(now.getMonth() + 1);
	}
	now.setDate(sday);
	now.setHours(0);
	now.setMinutes(0);
	now.setSeconds(0);
	var nexttime = now.getTime();
	var remain = nexttime - nowtime;
	var dayt = 24 * 60 * 60 * 1000;
	var ht = 60 * 60 * 1000;
	var d = Math.floor(remain / dayt);
	remain = remain % dayt;
	var h = Math.floor(remain / ht);
	remain = remain % ht;
	var m = Math.floor(remain / (60 * 1000));
	str = d + "d " + h + "h " + m + "min";

	$("#r-time").html(str);
}

function getClearTime() {
	if (resetdate == "") {
		resetdate = "--"
	}
	$("#clear-time").html(resetdate);
}