var daysOfMonth = new Array(
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
);

var daysOfMonthLY = new Array(
	31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
);

function isLeapYear(year) {
	year = year - 0;
	if ((year / 4) != Math.floor(year / 4)) return false;
	if ((year / 100) != Math.floor(year / 100)) return true;
	if ((year / 400) != Math.floor(year / 400)) return false;
	return true;
}

function isValidDate(day, month, year) {
	day = day - 0;
	month = month - 0;
	year = year - 0;
	if ((isLeapYear(year) && day > daysOfMonthLY[month - 1]) ||
		(!isLeapYear(year) && day > daysOfMonth[month - 1]))
		return false;
	else
		return true;
}

//This is the public function used to validate IP address, be careful when you need to modify it.
function validateIp(val) {
	if (val.length == 0) return true;
	//[250-255][200-249][100-199][00-99][0-9][000]
	ip = '(25[0-5]|2[0-4]\\d|1\\d\\d|\\d\\d|\\d|000)';
	ipdot = ip + '\\.';
	first_num = '(22[0-3]|2[0-1]\\d|1\\d\\d|\\d\\d|\\d|000)';

	isIPaddress = new RegExp('^' + ipdot + ipdot + ipdot + ip + '$');
	if (!isIPaddress.test(val)) {
		father.jAlert(alert138);
		return false;
	}

	isIPaddress = new RegExp('^' + first_num + '\\.' + ipdot + ipdot + ip + '$');
	if (!isIPaddress.test(val)) {
		father.jAlert(alert139);
		return false;
	}

	isIPaddress = new RegExp('^' + '(127|000|00|0)' + '\\.' + ipdot + ipdot + ip + '$');
	if (isIPaddress.test(val)) {
		father.jAlert(alert140);
		return false;
	}

	isIPaddress = new RegExp('^' + ipdot + ipdot + ipdot + '(255|000|00|0)' + '$');
	if (isIPaddress.test(val)) {
		father.jAlert(alert141);
		return false;
	}

	return true;
}

function validateLanIp(val) {
	if (val.length == 0) {
		father.jAlert(alert145);
		return false;
	}
	if (validatetheIp(val) == false) return false;

	var ii;
	sval = String(val);
	i1 = val.indexOf('.');
	sub1 = val.substring(0, i1);

	tempval = val.substring(i1 + 1, val.length);
	i2 = tempval.indexOf('.');
	sub2 = tempval.substring(0, i2);

	tempval = tempval.substring(i2 + 1, tempval.length);
	i3 = tempval.indexOf('.');
	sub3 = tempval.substring(0, i3);

	tempval = tempval.substring(i3 + 1, tempval.length);
	i4 = tempval.indexOf('.');
	sub4 = tempval.substring(0, tempval.length);

	if (val == '0.0.0.0') {
		father.jAlert(alert146);
		return false;
	}
	if (sub1 == '0') {
		father.jAlert(alert147);
		return false;
	}
	if (sub4 == '0' || sub4 == '255') {
		father.jAlert(alert148);
		return false;
	}
	if (sub1 == '127') {
		father.jAlert(alert149);
		return false;
	}
	if ((sub1 - 0) < 0 || (sub1 - 0) > 255 || (sub2 - 0) < 0 || (sub2 - 0) > 255 || (sub3 - 0) < 0 || (sub3 - 0) > 255 || (sub4 - 0) < 0 || (sub4 - 0) > 255) {
		father.jAlert(alert150);
		return false;
	} //added by kevin


	if ((sub1 - 0) > 223) {
		father.jAlert(alert151);
		return false;
	}

	return true;
}

//Added by fish for static route
function validateStaticRouteIp(val, mask) {
	if (val.length == 0) {
		father.jAlert(alert145);
		return false;
	}
	if (validatetheIp(val) == false) return false;

	var ii;
	sval = String(val);
	i1 = val.indexOf('.');
	sub1 = val.substring(0, i1);

	tempval = val.substring(i1 + 1, val.length);
	i2 = tempval.indexOf('.');
	sub2 = tempval.substring(0, i2);

	tempval = tempval.substring(i2 + 1, tempval.length);
	i3 = tempval.indexOf('.');
	sub3 = tempval.substring(0, i3);

	tempval = tempval.substring(i3 + 1, tempval.length);
	i4 = tempval.indexOf('.');
	sub4 = tempval.substring(0, tempval.length);

	if (val == '0.0.0.0') {
		father.jAlert(alert146);
		return false;
	}
	if (sub1 == '0') {
		father.jAlert(alert147);
		return false;
	}
	if (sub4 == '255') {
		father.jAlert(alert152);
		return false;
	}
	if (sub4 == '0' && mask == '255.255.255.255') {
		father.jAlert(alert153);
		return false;
	}
	if (sub1 == '127') {
		father.jAlert(alert149);
		return false;
	}
	if ((sub1 - 0) < 0 || (sub1 - 0) > 255 || (sub2 - 0) < 0 || (sub2 - 0) > 255 || (sub3 - 0) < 0 || (sub3 - 0) > 255 || (sub4 - 0) < 0 || (sub4 - 0) > 255) {
		father.jAlert(alert150);
		return false;
	}

	if ((sub1 - 0) > 223) {
		father.jAlert(alert151);
		return false;
	}
	return true;
}

function validateLanNetmask(val) {
	if (val != '255.255.255.0' && val != '255.255.255.128' && val != '255.255.255.192' && val != '255.255.255.224' &&
		val != '255.255.255.240' && val != '255.255.255.248' && val != '255.255.255.252' && val != '255.255.255.254') {
		father.jAlert(alert154);
		return false;
	}
	return true;
}

function validateYear(val) {

	var bool = true;
	var i = 0;

	if (val.length != 4 || val < 0000)
		bool = false;
	if (bool == false) {
		father.jAlert(alert155);
		return false;
	}
	for (i = 0; i < val.length; i++) {
		if (val.charAt(i) < '0' || val.charAt(i) > '9') {
			father.jAlert(sprintf(alert156, val.charAt(i), (i + 1)));
			return false;
		}
	}
	if ((val - 0) < 1970 || (val - 0) > 2037) {
		father.jAlert(alert157);
		return false;
	}
	return true;
}

function validateMonth(val) {
	var i = 0;

	month = val - 0;
	if (val.length != 2 || month < 1 || month > 12) {
		father.jAlert(alert158);
		return false;
	}
	for (i = 0; i < val.length; i++) {
		if (val.charAt(i) < '0' || val.charAt(i) > '9') {
			father.jAlert(sprintf(alert156, val.charAt(i), (i + 1)));
			return false;
		}
	}
	return true;
}




function validateHour(val) {
	var i = 0;

	hour = val - 0;
	if (val.length != 2 || hour < 0 || hour > 23) {
		father.jAlert(alert161);
		return false;
	}
	for (i = 0; i < val.length; i++) {
		if (val.charAt(i) < '0' || val.charAt(i) > '9') {
			father.jAlert(sprintf(alert156, val.charAt(i), (i + 1)));
			return false;
		}
	}
	return true;
}

function validateMinute(val) {

	var i = 0;

	min = val - 0;
	if (val.length != 2 || min < 0 || min > 59) {
		father.jAlert(alert164);
		return false;
	}
	for (i = 0; i < val.length; i++) {
		if (val.charAt(i) < '0' || val.charAt(i) > '9') {
			father.jAlert(sprintf(alert156, val.charAt(i), (i + 1)));
			return false;
		}
	}
	return true;
}

function validateSecond(val) {
	return true;
}

function validateMTU(val) {
	var i = 0;

	mval = val;
	mval = mval - 0;
	if (val.length < 3 || mval < 128 || mval > 1492) {
		father.jAlert(alert162);
		return false;
	}
	for (i = 0; i < val.length; i++) {
		if (val.charAt(0) == '0') {
			father.jAlert(alert163);
			return false;
		}
		if (val.charAt(i) < '0' || val.charAt(i) > '9') {
			father.jAlert(sprintf(alert156, val.charAt(i), (i + 1)));
			return false;
		}
	}
	return true;
}

function validateMRU(val) {
	var i = 0;

	mval = val;
	mval = mval - 0;
	if (val.length < 3 || mval < 128 || mval > 1492) {
		father.jAlert(alert165);
		return false;
	}
	for (i = 0; i < val.length; i++) {
		if (val.charAt(0) == '0') {
			father.jAlert(alert163);
			return false;
		}
		if (val.charAt(i) < '0' || val.charAt(i) > '9') {
			father.jAlert(sprintf(alert156, val.charAt(i), (i + 1)));
			return false;
		}
	}
	return true;
}

function hex(val) {
	var h = (val - 0).toString(16);
	if (h.length == 1) h = '0' + h;
	return h.toUpperCase();
}

function Op_AND_4Byte(v1, v2) {
	var i;
	var var1 = new Array();
	var var2 = new Array();
	var result = '0x';

	for (i = 2, j = 0; i < 10; i += 2, j++) {
		var1[j] = '0x' + v1.substring(i, i + 2);
		var2[j] = '0x' + v2.substring(i, i + 2);
	}

	for (i = 0; i < 4; i++) {
		result = result + hex(var1[i] & var2[i]);
	}

	result = result - 0;
	return result;
}

function validateGateway(wanIp, netmaskIp, gatewayIp) {

	var i1, i2, i3, wip, nip, gip;
	var lan4, mask4, pool4, net_no, lo_broadcast;

	if (gatewayIp.length == 0) return true;
	if (validateWanIp(gatewayIp) == false) return false;

	i1 = wanIp.indexOf('.');
	i2 = wanIp.indexOf('.', (i1 + 1));
	i3 = wanIp.indexOf('.', (i2 + 1));
	wip = hex(wanIp.substring(0, i1)) + hex(wanIp.substring((i1 + 1), i2)) + hex(wanIp.substring((i2 + 1), i3)) + hex(wanIp.substring((i3 + 1), wanIp.length));
	wip = '0x' + wip;
	lan4 = wanIp.substring((i3 + 1), wanIp.length) - 0;

	i1 = netmaskIp.indexOf('.');
	i2 = netmaskIp.indexOf('.', (i1 + 1));
	i3 = netmaskIp.indexOf('.', (i2 + 1));
	nip = hex(netmaskIp.substring(0, i1)) + hex(netmaskIp.substring((i1 + 1), i2)) + hex(netmaskIp.substring((i2 + 1), i3)) + hex(netmaskIp.substring((i3 + 1), netmaskIp.length));
	nip = '0x' + nip;
	mask4 = netmaskIp.substring((i3 + 1), netmaskIp.length) - 0;

	i1 = gatewayIp.indexOf('.');
	i2 = gatewayIp.indexOf('.', (i1 + 1));
	i3 = gatewayIp.indexOf('.', (i2 + 1));
	gip = hex(gatewayIp.substring(0, i1)) + hex(gatewayIp.substring((i1 + 1), i2)) + hex(gatewayIp.substring((i2 + 1), i3)) + hex(gatewayIp.substring((i3 + 1), gatewayIp.length));
	gip = '0x' + gip;
	pool4 = gatewayIp.substring((i3 + 1), gatewayIp.length) - 0;

	if (Op_AND_4Byte(wip, nip) != Op_AND_4Byte(gip, nip)) {
		father.jAlert(sprintf(alert166, gatewayIp, wanIp, netmaskIp));
		return false;
	}

	net_no = (lan4 & mask4);
	lo_broadcast = (lan4 & mask4) + (255 - mask4);

	if (pool4 == net_no) {
		father.jAlert(sprintf(alert219, gatewayIp));
		return false;
	}
	if (pool4 == lo_broadcast) {
		father.jAlert(sprintf(alert220, gatewayIp));
		return false;
	}
	//if (pool4==lan4) {
	//	father.jAlert("Invalid Ip: " +gatewayIp+" is the LAN IP address.");
	//	return false;
	//}
	return true;
}


function validatePasswd(val1, val2) {
	if (val1 != val2) {
		father.jAlert(alert167);
		return false;
	}
	return true;
}


function validateMac(val) {
	var i;
	sval = String(val);

	if (sval.length > 0 && sval.length != 17) {
		father.jAlert(alert168);
		return false;
	}

	for (i = 0; i < sval.length; i++) {
		if ((i % 3) == 2) {
			if (sval.charAt(i) != ':') {
				father.jAlert(sprintf(alert169, (i + 1)));
				return false;
			}
		} else if (!((sval.charAt(i) >= '0' && sval.charAt(i) <= '9') ||
			(sval.charAt(i) >= 'A' && sval.charAt(i) <= 'F') ||
			(sval.charAt(i) >= 'a' && sval.charAt(i) <= 'f'))) {
			father.jAlert(sprintf(alert170, sval.charAt(i), (i + 1)));
			return false;
		}
	}
	var sub1 = val.substring(0, 2);
	var sub2 = val.substring(3, 5);
	var sub3 = val.substring(6, 8);
	var sub4 = val.substring(9, 11);
	var sub5 = val.substring(12, 14);
	var sub6 = val.substring(15);

	if (sub1 == 'ff' && sub2 == 'ff' && sub3 == 'ff' && sub4 == 'ff' && sub5 == 'ff' && sub6 == 'ff') {
		father.jAlert(alert171);
		return false;
	}
	if (sub1 == '00' && sub2 == '00' && sub3 == '00' && sub4 == '00' && sub5 == '00' && sub6 == '00') {
		father.jAlert(alert172);
		return false;
	}
	sub1 = '0x' + sub1;
	if ((sub1 & 1) == 1) {
		father.jAlert(alert173);
		return false;
	}
	return true;
}

function validateStartEndIp(lanip, netip, startip, endip) {
	if (endip.length == 0) return;
	if ((validateGateway(lanip, netip, endip)) == false) return false;

	i1 = startip.indexOf('.');
	i2 = startip.indexOf('.', (i1 + 1));
	i3 = startip.indexOf('.', (i2 + 1));
	sip = hex(startip.substring(0, i1)) + hex(startip.substring((i1 + 1), i2)) + hex(startip.substring((i2 + 1), i3)) + hex(startip.substring((i3 + 1), startip.length));
	sip = '0x' + sip;

	i1 = endip.indexOf('.');
	i2 = endip.indexOf('.', (i1 + 1));
	i3 = endip.indexOf('.', (i2 + 1));
	eip = hex(endip.substring(0, i1)) + hex(endip.substring((i1 + 1), i2)) + hex(endip.substring((i2 + 1), i3)) + hex(endip.substring((i3 + 1), endip.length));
	eip = '0x' + eip;

	if (sip > eip) {
		father.jAlert(alert51);
		return false;
	}
	return true;
}


function validateNumber(val) {
	var i = 0;

	for (i = 0; i < val.length; i++) {
		if (val.charAt(i) < '0' || val.charAt(i) > '9') {
			father.jAlert(sprintf(alert156, val.charAt(i), (i + 1)));
			return false;
		}
	}
	return true;
}

function validatePort(val) {
	if (val.length == 0) return true;
	if (validateNumber(val) == false) return false;
	if ((val - 0) < 1 || (val - 0) > 65535) {
		father.jAlert(alert175);
		return false;
	}
	return true;
}

function validateIdleTime(val) {
	if (validateNumber(val) == false) return false;
	if ((val - 0) < 1 || (val - 0) > 1440) {
		father.jAlert(alert176);
		return false;
	}
	return true;
}

function validatelength(val) {
	if (val.length > 63 || val.length <= 0) {
		father.jAlert(alert177);
		return false;
	}
	return true;
}

function validatehttp_username(val) {
	var i = 0;

	if (validatelength(val) == false) return false;
	for (i = 0; i < val.length; i++) {
		if (val.charAt(i) == ':') {
			father.jAlert(sprintf(alert178, i));
			return false;
		}
	}
	return true;
}

function validateSpecialChar(val) {
	var i = 0;
	var speChrLst = '&()<>,;?/\\';
	var speChrLstLen = speChrLst.length;

	for (i = 0; i < val.length; i++) {
		var ch = val.charAt(i);
		for (var ii = 0; ii < speChrLstLen; ii++) {
			if (ch == speChrLst.charAt(ii)) {
				father.jAlert(xxContentWarn + ' .. ' + ii);
				return false;
			}
		}
	}
	return true;
}


function validateStartEndPort(startval, endval) {
	if (endval.length == 0) return;
	if (validatePort(endval) == false) return false;
	start = startval;
	end = endval;
	start = start - 0;
	end = end - 0;
	if (startval.length == 0) {
		father.jAlert(alert180);
		return;
	}
	if (start > end) {
		father.jAlert(alert181);
		return false;
	}
	if (start < 0 || end < 0) {
		father.jAlert(alert182);
		return false;
	}
	return true;
}

function filterIp(lanip, netip, fip) {
	var i = 0;
	var tempip;

	i = fip.lastIndexOf('.');

	tempip = fip.substring(i + 1, fip.length);
	if (tempip == '*')
		tempip = fip.substring(0, i + 1) + '0';
	else tempip = fip;

	if (validateGateway(lanip, netip, tempip) == false)
		return false;
	return true;
}

function validateEt1Mac(val) {
	var i;
	sval = String(val);

	if (sval.length > 0 && sval.length != 17) {
		father.jAlert(alert168);
		return false;
	}

	for (i = 0; i < sval.length; i++) {
		if ((i % 3) == 2) {
			if (sval.charAt(i) != ':') {
				father.jAlert(sprintf(alert169, (i + 1)));
				return false;
			}
		} else if (!((sval.charAt(i) >= '0' && sval.charAt(i) <= '9') ||
			(sval.charAt(i) >= 'A' && sval.charAt(i) <= 'F') ||
			(sval.charAt(i) >= 'a' && sval.charAt(i) <= 'f'))) {
			father.jAlert(sprintf(alert170, sval.charAt(i), (i + 1)));
			return false;
		}
	}
	var sub1 = val.substring(0, 2);
	var sub2 = val.substring(3, 5);
	var sub3 = val.substring(6, 8);
	var sub4 = val.substring(9, 11);
	var sub5 = val.substring(12, 14);
	var sub6 = val.substring(15);

	if (sub1 == 'ff' && sub2 == 'ff' && sub3 == 'ff' && sub4 == 'ff' && sub5 == 'ff' && sub6 == 'ff') {
		father.jAlert(alert171);
		return false;
	}
	if (sub1 == '00' && sub2 == '00' && sub3 == '00' && sub4 == '00' && sub5 == '00' && sub6 == '00') {
		father.jAlert(alert183);
		return false;
	}
	sub1 = '0x' + sub1;
	if ((sub1 & 1) == 1) {
		father.jAlert(alert173);
		return false;
	}
	return true;
}



function validateNetMask(val) {
	if (val.length == 0) return true;
	if (val != '255.255.255.0' && val != '255.255.255.128' && val != '255.255.255.192' && val != '255.255.255.224' &&
		val != '255.255.255.240' && val != '255.255.255.248' && val != '255.255.255.252' && val != '255.255.255.254' && val != '255.255.255.255' &&
		val != '255.255.0.0' && val != '255.255.128.0' && val != '255.255.192.0' && val != '255.255.224.0' &&
		val != '255.255.240.0' && val != '255.255.248.0' && val != '255.255.252.0' && val != '255.255.254.0' &&
		val != '255.0.0.0' && val != '255.128.0.0' && val != '255.192.0.0' && val != '255.224.0.0' &&
		val != '255.240.0.0' && val != '255.248.0.0' && val != '255.252.0.0' && val != '255.254.0.0' &&
		val != '128.0.0.0' && val != '192.0.0.0' && val != '224.0.0.0' &&
		val != '240.0.0.0' && val != '248.0.0.0' && val != '252.0.0.0' && val != '254.0.0.0') {
		father.jAlert(alert185);
		return false;
	}
	return true;
}

function validateRouteIp(val) {
	if (val == '0.0.0.0' || val == '255.255.255.255') {
		father.jAlert(alert186);
		return false;
	}
	if (validateIp(val) == false) return false;
	return true;
}

function validateDhcpLease(val) {
	for (var i = 0; i < val.length; i++) {
		if (val.charAt(i) < '0' || val.charAt(i) > '9') {
			father.jAlert(alert11);
			return false;
		}
	}

	if ((val - 0) < 0) {
		father.jAlert(alert176_1);
		return false;
	}
	return true;
}

function validateWanIp(val) {
	if (validateIp(val) == false) return false;

	var ii;
	sval = String(val);
	i1 = val.indexOf('.');
	sub1 = val.substring(0, i1);

	tempval = val.substring(i1 + 1, val.length);
	i2 = tempval.indexOf('.');
	sub2 = tempval.substring(0, i2);

	tempval = tempval.substring(i2 + 1, tempval.length);
	i3 = tempval.indexOf('.');
	sub3 = tempval.substring(0, i3);

	tempval = tempval.substring(i3 + 1, tempval.length);
	i4 = tempval.indexOf('.');
	sub4 = tempval.substring(0, tempval.length);

	if (sub4 == '0' || sub4 == '00' || sub4 == '255') {
		father.jAlert(alert188);
		return false;
	}
	if (sub1 == '127') {
		father.jAlert(alert189);
		return false;
	}
	if (val == '0.0.0.0') {
		father.jAlert(alert190);
		return false;
	}

	if ((sub1 - 0) > 223) {
		father.jAlert(alert191);
		return false;
	}
	return true;
}

function validatetheIp(val) {
	if (val.length == 0) return;
	var ii;
	sval = String(val);
	if (val.length > 15) {
		father.jAlert(alert192);
		return false;
	}
	i1 = val.indexOf('.');
	if (i1 == -1) {
		father.jAlert(alert138);
		return false;
	}
	sub1 = val.substring(0, i1);

	tempval = val.substring(i1 + 1, val.length);
	i2 = tempval.indexOf('.');
	if (i2 == -1) {
		father.jAlert(alert193);
		return false;
	}
	sub2 = tempval.substring(0, i2);

	tempval = tempval.substring(i2 + 1, tempval.length);
	i3 = tempval.indexOf('.');
	if (i3 == -1) {
		father.jAlert(alert193);
		return false;
	}
	sub3 = tempval.substring(0, i3);

	tempval = tempval.substring(i3 + 1, tempval.length);
	i4 = tempval.indexOf('.');
	if (i4 != -1) {
		father.jAlert(alert193);
		return false;
	}
	sub4 = tempval.substring(0, tempval.length);

	if (sub1.length == 0 || sub2.length == 0 || sub3.length == 0 || sub4.length == 0) {
		father.jAlert(alert194);
		return false;
	}

	if ((sub1 - 0) < 0 || (sub1 - 0) > 255 || (sub2 - 0) < 0 || (sub2 - 0) > 255 ||
		(sub3 - 0) < 0 || (sub3 - 0) > 255 || (sub4 - 0) < 0 || (sub4 - 0) > 255) {
		father.jAlert(alert150);
		return false;
	}

	for (ii = 0; ii < sval.length; ii++) {
		if (sval.charAt(ii) == '.') {
			continue;
		} else if (sval.charAt(ii) < '0' || sval.charAt(ii) > '9') {
			father.jAlert(sprintf(alert195, sval.charAt(ii), (ii + 1)));
			return false;
		}
	}
	return true;
}

function validateDNS(val) {
	if (validatetheIp(val) == false) return false;

	var ii;
	sval = String(val);
	i1 = val.indexOf('.');
	sub1 = val.substring(0, i1);

	tempval = val.substring(i1 + 1, val.length);
	i2 = tempval.indexOf('.');
	sub2 = tempval.substring(0, i2);

	tempval = tempval.substring(i2 + 1, tempval.length);
	i3 = tempval.indexOf('.');
	sub3 = tempval.substring(0, i3);

	tempval = tempval.substring(i3 + 1, tempval.length);
	i4 = tempval.indexOf('.');
	sub4 = tempval.substring(0, tempval.length);


	if (sub1 == '127') {
		father.jAlert(alert149);
		return false;
	}
	if (val == '0.0.0.0') {
		father.jAlert(alert146);
		return false;
	}
	if (sub4 == '0' || sub4 == '255') {
		father.jAlert(alert148);
		return false;
	}
	if ((sub1 - 0) > 223) {
		father.jAlert(alert151);
		return false;
	}
	return true;
}

function validateStartEndIpPool(lanip, netip, startip, endip) {
	if (endip.length == 0) return;
	if ((validateGateway(lanip, netip, endip)) == false) return false;

	i1 = startip.indexOf('.');
	i2 = startip.indexOf('.', (i1 + 1));
	i3 = startip.indexOf('.', (i2 + 1));
	sip = hex(startip.substring(0, i1)) + hex(startip.substring((i1 + 1), i2)) + hex(startip.substring((i2 + 1), i3)) + hex(startip.substring((i3 + 1), startip.length));
	sip = '0x' + sip;

	i1 = endip.indexOf('.');
	i2 = endip.indexOf('.', (i1 + 1));
	i3 = endip.indexOf('.', (i2 + 1));
	eip = hex(endip.substring(0, i1)) + hex(endip.substring((i1 + 1), i2)) + hex(endip.substring((i2 + 1), i3)) + hex(endip.substring((i3 + 1), endip.length));
	eip = '0x' + eip;

	if (sip > eip) {
		father.jAlert(alert51);
		return false;
	}

	i1 = lanip.indexOf('.');
	i2 = lanip.indexOf('.', (i1 + 1));
	i3 = lanip.indexOf('.', (i2 + 1));
	nip = hex(lanip.substring(0, i1)) + hex(lanip.substring((i1 + 1), i2)) + hex(lanip.substring((i2 + 1), i3)) + hex(lanip.substring((i3 + 1), lanip.length));
	nip = '0x' + nip;

	if (nip >= sip && nip <= eip) {
		father.jAlert(alert196);
		return false;
	}
	return true;
}

function validateIPReservation(ar_list, startip, endip) {
	var rule_item = '';
	var item_count = 0;

	i1 = startip.indexOf('.');
	i2 = startip.indexOf('.', (i1 + 1));
	i3 = startip.indexOf('.', (i2 + 1));
	sip = hex(startip.substring((i3 + 1), startip.length));
	sip = '0x' + sip;
	i1 = endip.indexOf('.');
	i2 = endip.indexOf('.', (i1 + 1));
	i3 = endip.indexOf('.', (i2 + 1));
	eip = hex(endip.substring((i3 + 1), endip.length));
	eip = '0x' + eip;
	if (ar_list != '') {
		rule_item = ar_list.split('^');
		item_count = rule_item.length;
	}
	for (i = 0; i <= item_count; i++) {
		if (rule_item[i] == '') {} else {
			i1 = rule_item[i].indexOf('~');
			i2 = rule_item[i].indexOf('~', (i1 + 1));
			i3 = rule_item[i].indexOf('~', (i2 + 1));
			arenable = hex(rule_item[i].substring(0, i1));
			arenable = '0x' + arenable;
			arip = hex(rule_item[i].substring((i2 + 1), i3));
			arip = '0x' + arip;
			if (arenable > 0 && (arip >= eip || arip <= sip)) {
				father.jAlert(sprintf(alert197, (i + 1), startip, endip));
				return false;
			}
		}

	}
	return true;
}

function validateWanIP_router(val, mask) {
	if (validatetheIp(val) == false) return false;

	var ii;
	sval = String(val);
	i1 = val.indexOf('.');
	sub1 = val.substring(0, i1);

	tempval = val.substring(i1 + 1, val.length);
	i2 = tempval.indexOf('.');
	sub2 = tempval.substring(0, i2);

	tempval = tempval.substring(i2 + 1, tempval.length);
	i3 = tempval.indexOf('.');
	sub3 = tempval.substring(0, i3);

	tempval = tempval.substring(i3 + 1, tempval.length);
	i4 = tempval.indexOf('.');
	sub4 = tempval.substring(0, tempval.length);


	if (sub1 == '127') {
		father.jAlert(alert149);
		return false;
	}
	if (val == '0.0.0.0') {
		father.jAlert(alert146);
		return false;
	}
	if (sub4 == '255') {
		father.jAlert(alert152);
		return false;
	}
	if (sub4 == '0' && mask == '255.255.255.255') {
		father.jAlert(alert153);
		return false;
	}
	if ((sub1 - 0) > 223) {
		father.jAlert(alert151);
		return false;
	}
	return true;
}

function validateWanIP_Manual(val, mask) {
	if (validatetheIp(val) == false) return false;

	var ii;
	sval = String(val);
	i1 = val.indexOf('.');
	sub1 = val.substring(0, i1);

	tempval = val.substring(i1 + 1, val.length);
	i2 = tempval.indexOf('.');
	sub2 = tempval.substring(0, i2);

	tempval = tempval.substring(i2 + 1, tempval.length);
	i3 = tempval.indexOf('.');
	sub3 = tempval.substring(0, i3);

	tempval = tempval.substring(i3 + 1, tempval.length);
	i4 = tempval.indexOf('.');
	sub4 = tempval.substring(0, tempval.length);


	if (sub1 == '127') {
		father.jAlert(alert149);
		return false;
	}
	if (val == '0.0.0.0') {
		father.jAlert(alert146);
		return false;
	}
	if (sub4 == '255') {
		father.jAlert(alert152);
		return false;
	}
	if (sub1 == '0') {
		father.jAlert(alert147);
	}
	if ((sub1 - 0) > 223) {
		father.jAlert(alert151);
		return false;
	}
	return true;
}

function validateNTPServerIP(val) {
	if (validateIp(val) == false) return false;
	return true;
}

function validateRemoteManagementIP(val) {
	if (validateIp(val) == false) return false;
	return true;
}

function validatePINCode(val) //wendy add
	{
		if (val.length > 8 || val.length < 4) {
			father.jAlert(alertPINLength);
			return false;
		}
		if (validateNumber(val) == false)
			return false;
		return true;
	}

function validatePUK(val) //wendy add
	{
		if (val.length != 8) {
			father.jAlert(alertPUKLength);
			return false;
		}
		if (validateNumber(val) == false)
			return false;
		return true;
	}

function validateTwoInput(val1, val2) {
	if (val1 != val2) {
		father.jAlert(alertReconfirmPIN);
		return false;
	}
	return true;
}

function validateComment(val) {
	var k;
	for (k = 0; k < val.length; k++) {
		if ((val.charAt(k) == ',') || (val.charAt(k) == ';')) {
			father.jAlert(sprintf(alert43, val.charAt(k), (k + 1)));
			return false;
		}
	}
	return true;
}

function CheckInjection(str) {
	var len = str.length;
	for (var i = 0; i < str.length; i++) {
		if (str.charAt(i) == ';' || str.charAt(i) == ',' || str.charAt(i) == '\r' || str.charAt(i) == '\n' || str.charAt(i) == '?' || str.charAt(i) == '=' || str.charAt(i) == '/')
			return false;
		else
			continue;
	}
	return true;
}

// check if no value then return empty
function chkV(arg) {
	if (typeof arg == 'undefined' || arg == null || arg == '(null)') return '';
	return arg;
}


function str_repeat(i, m) {
	for (var o = []; m > 0; o[--m] = i);
	return (o.join(''));
}

function sprintf() {
	var i = 0,
		a, f = arguments[i++],
		o = [],
		m, p, c, x;
	while (f) {
		if (m = /^[^\x25]+/.exec(f)) o.push(m[0]);
		else if (m = /^\x25{2}/.exec(f)) o.push('%');
		else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(f)) {
			if (((a = arguments[m[1] || i++]) == null) || (a == undefined)) throw ("Too few arguments.");
			if (/[^s]/.test(m[7]) && (typeof(a) != 'number'))
				throw ("Expecting number but found " + typeof(a));
			switch (m[7]) {
				case 'b':
					a = a.toString(2);
					break;
				case 'c':
					a = String.fromCharCode(a);
					break;
				case 'd':
					a = parseInt(a);
					break;
				case 'e':
					a = m[6] ? a.toExponential(m[6]) : a.toExponential();
					break;
				case 'f':
					a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a);
					break;
				case 'o':
					a = a.toString(8);
					break;
				case 's':
					a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a);
					break;
				case 'u':
					a = Math.abs(a);
					break;
				case 'x':
					a = a.toString(16);
					break;
				case 'X':
					a = a.toString(16).toUpperCase();
					break;
			}
			a = (/[def]/.test(m[7]) && m[2] && a > 0 ? '+' + a : a);
			c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
			x = m[5] - String(a).length;
			p = m[5] ? str_repeat(c, x) : '';
			o.push(m[4] ? a + p : p + a);
		} else throw ("Huh ?!");
		f = f.substring(m[0].length);
	}
	return o.join('');
}